/* App.c generated by valac 0.56.18, the Vala compiler
 * generated from App.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *           2013-2014 Akshay Shekher
 *           2011-2012 Giulio Collura
 *           2020-2021 Justin Haygood
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "slingshot.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gio/gdesktopappinfo.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SLINGSHOT_BACKEND_APP_0_PROPERTY,
	SLINGSHOT_BACKEND_APP_NAME_PROPERTY,
	SLINGSHOT_BACKEND_APP_DESCRIPTION_PROPERTY,
	SLINGSHOT_BACKEND_APP_DESKTOP_ID_PROPERTY,
	SLINGSHOT_BACKEND_APP_EXEC_PROPERTY,
	SLINGSHOT_BACKEND_APP_KEYWORDS_PROPERTY,
	SLINGSHOT_BACKEND_APP_ICON_PROPERTY,
	SLINGSHOT_BACKEND_APP_POPULARITY_PROPERTY,
	SLINGSHOT_BACKEND_APP_DESKTOP_PATH_PROPERTY,
	SLINGSHOT_BACKEND_APP_CATEGORIES_PROPERTY,
	SLINGSHOT_BACKEND_APP_GENERIC_NAME_PROPERTY,
	SLINGSHOT_BACKEND_APP_PREFERS_DEFAULT_GPU_PROPERTY,
	SLINGSHOT_BACKEND_APP_APP_TYPE_PROPERTY,
	SLINGSHOT_BACKEND_APP_COUNT_VISIBLE_PROPERTY,
	SLINGSHOT_BACKEND_APP_CURRENT_COUNT_PROPERTY,
	SLINGSHOT_BACKEND_APP_MATCH_PROPERTY,
	SLINGSHOT_BACKEND_APP_TARGET_PROPERTY,
	SLINGSHOT_BACKEND_APP_NUM_PROPERTIES
};
static GParamSpec* slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	SLINGSHOT_BACKEND_APP_LAUNCHED_SIGNAL,
	SLINGSHOT_BACKEND_APP_START_SEARCH_SIGNAL,
	SLINGSHOT_BACKEND_APP_NUM_SIGNALS
};
static guint slingshot_backend_app_signals[SLINGSHOT_BACKEND_APP_NUM_SIGNALS] = {0};

struct _SlingshotBackendAppPrivate {
	gchar* _name;
	gchar* _description;
	gchar* _desktop_id;
	gchar* _exec;
	gchar** _keywords;
	gint _keywords_length1;
	gint __keywords_size_;
	GIcon* _icon;
	gdouble _popularity;
	gchar* _desktop_path;
	gchar* _categories;
	gchar* _generic_name;
	gboolean _prefers_default_gpu;
	SlingshotBackendAppAppType _app_type;
	gchar* unity_sender_name;
	gboolean _count_visible;
	gint64 _current_count;
	SynapseMatch* _match;
	SynapseMatch* _target;
	SlingshotBackendSwitcherooControl* switcheroo_control;
};

static gint SlingshotBackendApp_private_offset;
static gpointer slingshot_backend_app_parent_class = NULL;

static void slingshot_backend_app_set_app_type (SlingshotBackendApp* self,
                                         SlingshotBackendAppAppType value);
static void slingshot_backend_app_set_description (SlingshotBackendApp* self,
                                            const gchar* value);
static void slingshot_backend_app_set_exec (SlingshotBackendApp* self,
                                     const gchar* value);
static void slingshot_backend_app_set_desktop_path (SlingshotBackendApp* self,
                                             const gchar* value);
static void slingshot_backend_app_set_keywords (SlingshotBackendApp* self,
                                         gchar** value,
                                         gint value_length1);
static void slingshot_backend_app_set_categories (SlingshotBackendApp* self,
                                           const gchar* value);
static void slingshot_backend_app_set_generic_name (SlingshotBackendApp* self,
                                             const gchar* value);
static void slingshot_backend_app_set_prefers_default_gpu (SlingshotBackendApp* self,
                                                    gboolean value);
static void slingshot_backend_app_set_icon (SlingshotBackendApp* self,
                                     GIcon* value);
static void slingshot_backend_app_set_match (SlingshotBackendApp* self,
                                      SynapseMatch* value);
static void slingshot_backend_app_set_target (SlingshotBackendApp* self,
                                       SynapseMatch* value);
static void slingshot_backend_app_set_current_count (SlingshotBackendApp* self,
                                              gint64 value);
static void slingshot_backend_app_set_count_visible (SlingshotBackendApp* self,
                                              gboolean value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * slingshot_backend_app_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void slingshot_backend_app_finalize (GObject * obj);
static GType slingshot_backend_app_get_type_once (void);
static void _vala_slingshot_backend_app_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_slingshot_backend_app_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
slingshot_backend_app_get_instance_private (SlingshotBackendApp* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotBackendApp_private_offset);
}

static GType
slingshot_backend_app_app_type_get_type_once (void)
{
	static const GEnumValue values[] = {{SLINGSHOT_BACKEND_APP_APP_TYPE_APP, "SLINGSHOT_BACKEND_APP_APP_TYPE_APP", "app"}, {SLINGSHOT_BACKEND_APP_APP_TYPE_COMMAND, "SLINGSHOT_BACKEND_APP_APP_TYPE_COMMAND", "command"}, {SLINGSHOT_BACKEND_APP_APP_TYPE_SYNAPSE, "SLINGSHOT_BACKEND_APP_APP_TYPE_SYNAPSE", "synapse"}, {0, NULL, NULL}};
	GType slingshot_backend_app_app_type_type_id;
	slingshot_backend_app_app_type_type_id = g_enum_register_static ("SlingshotBackendAppAppType", values);
	return slingshot_backend_app_app_type_type_id;
}

GType
slingshot_backend_app_app_type_get_type (void)
{
	static volatile gsize slingshot_backend_app_app_type_type_id__once = 0;
	if (g_once_init_enter (&slingshot_backend_app_app_type_type_id__once)) {
		GType slingshot_backend_app_app_type_type_id;
		slingshot_backend_app_app_type_type_id = slingshot_backend_app_app_type_get_type_once ();
		g_once_init_leave (&slingshot_backend_app_app_type_type_id__once, slingshot_backend_app_app_type_type_id);
	}
	return slingshot_backend_app_app_type_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 73 "../src/Backend/App.vala"
	return self ? g_object_ref (self) : NULL;
#line 193 "App.c"
}

SlingshotBackendApp*
slingshot_backend_app_construct (GType object_type,
                                 GDesktopAppInfo* info)
{
	SlingshotBackendApp * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GIcon* desktop_icon = NULL;
	GIcon* _tmp11_;
	GIcon* _tmp12_;
	GIcon* _tmp13_;
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp15_;
	GtkIconTheme* _tmp16_;
	GIcon* _tmp17_;
	GtkIconInfo* _tmp18_;
	GtkIconInfo* _tmp19_;
	gboolean _tmp20_;
#line 59 "../src/Backend/App.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 59 "../src/Backend/App.vala"
	self = (SlingshotBackendApp*) g_object_new (object_type, NULL);
#line 61 "../src/Backend/App.vala"
	slingshot_backend_app_set_app_type (self, SLINGSHOT_BACKEND_APP_APP_TYPE_APP);
#line 63 "../src/Backend/App.vala"
	_tmp0_ = g_app_info_get_display_name ((GAppInfo*) info);
#line 63 "../src/Backend/App.vala"
	slingshot_backend_app_set_name (self, _tmp0_);
#line 64 "../src/Backend/App.vala"
	_tmp2_ = g_app_info_get_description ((GAppInfo*) info);
#line 64 "../src/Backend/App.vala"
	_tmp1_ = _tmp2_;
#line 64 "../src/Backend/App.vala"
	if (_tmp1_ == NULL) {
#line 238 "App.c"
		const gchar* _tmp3_;
#line 64 "../src/Backend/App.vala"
		_tmp3_ = self->priv->_name;
#line 64 "../src/Backend/App.vala"
		_tmp1_ = _tmp3_;
#line 244 "App.c"
	}
#line 64 "../src/Backend/App.vala"
	slingshot_backend_app_set_description (self, _tmp1_);
#line 65 "../src/Backend/App.vala"
	_tmp4_ = g_app_info_get_commandline ((GAppInfo*) info);
#line 65 "../src/Backend/App.vala"
	slingshot_backend_app_set_exec (self, _tmp4_);
#line 66 "../src/Backend/App.vala"
	_tmp5_ = g_app_info_get_id ((GAppInfo*) info);
#line 66 "../src/Backend/App.vala"
	slingshot_backend_app_set_desktop_id (self, _tmp5_);
#line 67 "../src/Backend/App.vala"
	_tmp6_ = g_desktop_app_info_get_filename (info);
#line 67 "../src/Backend/App.vala"
	slingshot_backend_app_set_desktop_path (self, _tmp6_);
#line 68 "../src/Backend/App.vala"
	_tmp8_ = _tmp7_ = g_desktop_app_info_get_keywords (info);
#line 68 "../src/Backend/App.vala"
	slingshot_backend_app_set_keywords (self, _tmp8_, _vala_array_length (_tmp7_));
#line 69 "../src/Backend/App.vala"
	_tmp9_ = g_desktop_app_info_get_categories (info);
#line 69 "../src/Backend/App.vala"
	slingshot_backend_app_set_categories (self, _tmp9_);
#line 70 "../src/Backend/App.vala"
	_tmp10_ = g_desktop_app_info_get_generic_name (info);
#line 70 "../src/Backend/App.vala"
	slingshot_backend_app_set_generic_name (self, _tmp10_);
#line 71 "../src/Backend/App.vala"
	slingshot_backend_app_set_prefers_default_gpu (self, !g_desktop_app_info_get_boolean (info, "PrefersNonDefaultGPU"));
#line 73 "../src/Backend/App.vala"
	_tmp11_ = g_app_info_get_icon ((GAppInfo*) info);
#line 73 "../src/Backend/App.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 73 "../src/Backend/App.vala"
	desktop_icon = _tmp12_;
#line 74 "../src/Backend/App.vala"
	_tmp13_ = desktop_icon;
#line 74 "../src/Backend/App.vala"
	if (_tmp13_ != NULL) {
#line 284 "App.c"
		GIcon* _tmp14_;
#line 75 "../src/Backend/App.vala"
		_tmp14_ = desktop_icon;
#line 75 "../src/Backend/App.vala"
		slingshot_backend_app_set_icon (self, _tmp14_);
#line 290 "App.c"
	}
#line 78 "../src/Backend/App.vala"
	_tmp15_ = gtk_icon_theme_get_default ();
#line 78 "../src/Backend/App.vala"
	theme = _tmp15_;
#line 79 "../src/Backend/App.vala"
	_tmp16_ = theme;
#line 79 "../src/Backend/App.vala"
	_tmp17_ = self->priv->_icon;
#line 79 "../src/Backend/App.vala"
	_tmp18_ = gtk_icon_theme_lookup_by_gicon (_tmp16_, _tmp17_, 64, GTK_ICON_LOOKUP_USE_BUILTIN);
#line 79 "../src/Backend/App.vala"
	_tmp19_ = _tmp18_;
#line 79 "../src/Backend/App.vala"
	_tmp20_ = _tmp19_ == NULL;
#line 79 "../src/Backend/App.vala"
	_g_object_unref0 (_tmp19_);
#line 79 "../src/Backend/App.vala"
	if (_tmp20_) {
#line 310 "App.c"
		GThemedIcon* _tmp21_;
		GThemedIcon* _tmp22_;
#line 80 "../src/Backend/App.vala"
		_tmp21_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 80 "../src/Backend/App.vala"
		_tmp22_ = _tmp21_;
#line 80 "../src/Backend/App.vala"
		slingshot_backend_app_set_icon (self, (GIcon*) _tmp22_);
#line 80 "../src/Backend/App.vala"
		_g_object_unref0 (_tmp22_);
#line 321 "App.c"
	}
#line 59 "../src/Backend/App.vala"
	_g_object_unref0 (desktop_icon);
#line 59 "../src/Backend/App.vala"
	return self;
#line 327 "App.c"
}

SlingshotBackendApp*
slingshot_backend_app_new (GDesktopAppInfo* info)
{
#line 59 "../src/Backend/App.vala"
	return slingshot_backend_app_construct (SLINGSHOT_BACKEND_TYPE_APP, info);
#line 335 "App.c"
}

SlingshotBackendApp*
slingshot_backend_app_construct_from_command (GType object_type,
                                              const gchar* command)
{
	SlingshotBackendApp * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 84 "../src/Backend/App.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 84 "../src/Backend/App.vala"
	self = (SlingshotBackendApp*) g_object_new (object_type, NULL);
#line 85 "../src/Backend/App.vala"
	slingshot_backend_app_set_app_type (self, SLINGSHOT_BACKEND_APP_APP_TYPE_COMMAND);
#line 87 "../src/Backend/App.vala"
	slingshot_backend_app_set_name (self, command);
#line 88 "../src/Backend/App.vala"
	slingshot_backend_app_set_description (self, _ ("Run this command…"));
#line 89 "../src/Backend/App.vala"
	slingshot_backend_app_set_exec (self, command);
#line 90 "../src/Backend/App.vala"
	slingshot_backend_app_set_desktop_id (self, command);
#line 91 "../src/Backend/App.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("system-run");
#line 91 "../src/Backend/App.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/Backend/App.vala"
	slingshot_backend_app_set_icon (self, (GIcon*) _tmp1_);
#line 91 "../src/Backend/App.vala"
	_g_object_unref0 (_tmp1_);
#line 84 "../src/Backend/App.vala"
	return self;
#line 369 "App.c"
}

SlingshotBackendApp*
slingshot_backend_app_new_from_command (const gchar* command)
{
#line 84 "../src/Backend/App.vala"
	return slingshot_backend_app_construct_from_command (SLINGSHOT_BACKEND_TYPE_APP, command);
#line 377 "App.c"
}

SlingshotBackendApp*
slingshot_backend_app_construct_from_synapse_match (GType object_type,
                                                    SynapseMatch* match,
                                                    SynapseMatch* target)
{
	SlingshotBackendApp * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	SynapseMatchType _tmp5_;
	SynapseMatchType _tmp6_;
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp21_;
	GtkIconTheme* _tmp22_;
	GIcon* _tmp23_;
	GtkIconInfo* _tmp24_;
	GtkIconInfo* _tmp25_;
	gboolean _tmp26_;
#line 94 "../src/Backend/App.vala"
	g_return_val_if_fail (match != NULL, NULL);
#line 94 "../src/Backend/App.vala"
	self = (SlingshotBackendApp*) g_object_new (object_type, NULL);
#line 95 "../src/Backend/App.vala"
	slingshot_backend_app_set_app_type (self, SLINGSHOT_BACKEND_APP_APP_TYPE_SYNAPSE);
#line 97 "../src/Backend/App.vala"
	_tmp0_ = synapse_match_get_title (match);
#line 97 "../src/Backend/App.vala"
	_tmp1_ = _tmp0_;
#line 97 "../src/Backend/App.vala"
	slingshot_backend_app_set_name (self, _tmp1_);
#line 98 "../src/Backend/App.vala"
	_tmp2_ = synapse_match_get_description (match);
#line 98 "../src/Backend/App.vala"
	_tmp3_ = _tmp2_;
#line 98 "../src/Backend/App.vala"
	slingshot_backend_app_set_description (self, _tmp3_);
#line 100 "../src/Backend/App.vala"
	_tmp5_ = synapse_match_get_match_type (match);
#line 100 "../src/Backend/App.vala"
	_tmp6_ = _tmp5_;
#line 100 "../src/Backend/App.vala"
	if (_tmp6_ == SYNAPSE_MATCH_TYPE_CONTACT) {
#line 424 "App.c"
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 100 "../src/Backend/App.vala"
		_tmp7_ = synapse_match_get_has_thumbnail (match);
#line 100 "../src/Backend/App.vala"
		_tmp8_ = _tmp7_;
#line 100 "../src/Backend/App.vala"
		_tmp4_ = _tmp8_;
#line 433 "App.c"
	} else {
#line 100 "../src/Backend/App.vala"
		_tmp4_ = FALSE;
#line 437 "App.c"
	}
#line 100 "../src/Backend/App.vala"
	if (_tmp4_) {
#line 441 "App.c"
		GFile* file = NULL;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		GFileIcon* _tmp13_;
		GFileIcon* _tmp14_;
#line 101 "../src/Backend/App.vala"
		_tmp9_ = synapse_match_get_thumbnail_path (match);
#line 101 "../src/Backend/App.vala"
		_tmp10_ = _tmp9_;
#line 101 "../src/Backend/App.vala"
		_tmp11_ = g_file_new_for_path (_tmp10_);
#line 101 "../src/Backend/App.vala"
		file = _tmp11_;
#line 102 "../src/Backend/App.vala"
		_tmp12_ = file;
#line 102 "../src/Backend/App.vala"
		_tmp13_ = (GFileIcon*) g_file_icon_new (_tmp12_);
#line 102 "../src/Backend/App.vala"
		_tmp14_ = _tmp13_;
#line 102 "../src/Backend/App.vala"
		slingshot_backend_app_set_icon (self, (GIcon*) _tmp14_);
#line 102 "../src/Backend/App.vala"
		_g_object_unref0 (_tmp14_);
#line 100 "../src/Backend/App.vala"
		_g_object_unref0 (file);
#line 469 "App.c"
	} else {
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 103 "../src/Backend/App.vala"
		_tmp15_ = synapse_match_get_icon_name (match);
#line 103 "../src/Backend/App.vala"
		_tmp16_ = _tmp15_;
#line 103 "../src/Backend/App.vala"
		if (_tmp16_ != NULL) {
#line 479 "App.c"
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			GThemedIcon* _tmp19_;
			GThemedIcon* _tmp20_;
#line 104 "../src/Backend/App.vala"
			_tmp17_ = synapse_match_get_icon_name (match);
#line 104 "../src/Backend/App.vala"
			_tmp18_ = _tmp17_;
#line 104 "../src/Backend/App.vala"
			_tmp19_ = (GThemedIcon*) g_themed_icon_new (_tmp18_);
#line 104 "../src/Backend/App.vala"
			_tmp20_ = _tmp19_;
#line 104 "../src/Backend/App.vala"
			slingshot_backend_app_set_icon (self, (GIcon*) _tmp20_);
#line 104 "../src/Backend/App.vala"
			_g_object_unref0 (_tmp20_);
#line 496 "App.c"
		}
	}
#line 107 "../src/Backend/App.vala"
	_tmp21_ = gtk_icon_theme_get_default ();
#line 107 "../src/Backend/App.vala"
	theme = _tmp21_;
#line 108 "../src/Backend/App.vala"
	_tmp22_ = theme;
#line 108 "../src/Backend/App.vala"
	_tmp23_ = self->priv->_icon;
#line 108 "../src/Backend/App.vala"
	_tmp24_ = gtk_icon_theme_lookup_by_gicon (_tmp22_, _tmp23_, 64, GTK_ICON_LOOKUP_USE_BUILTIN);
#line 108 "../src/Backend/App.vala"
	_tmp25_ = _tmp24_;
#line 108 "../src/Backend/App.vala"
	_tmp26_ = _tmp25_ == NULL;
#line 108 "../src/Backend/App.vala"
	_g_object_unref0 (_tmp25_);
#line 108 "../src/Backend/App.vala"
	if (_tmp26_) {
#line 517 "App.c"
		GThemedIcon* _tmp27_;
		GThemedIcon* _tmp28_;
#line 109 "../src/Backend/App.vala"
		_tmp27_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 109 "../src/Backend/App.vala"
		_tmp28_ = _tmp27_;
#line 109 "../src/Backend/App.vala"
		slingshot_backend_app_set_icon (self, (GIcon*) _tmp28_);
#line 109 "../src/Backend/App.vala"
		_g_object_unref0 (_tmp28_);
#line 528 "App.c"
	}
#line 112 "../src/Backend/App.vala"
	if (SYNAPSE_IS_APPLICATION_MATCH (match)) {
#line 532 "App.c"
		SynapseApplicationMatch* app_match = NULL;
		SynapseApplicationMatch* _tmp29_;
		GAppInfo* app_info = NULL;
		SynapseApplicationMatch* _tmp30_;
		GAppInfo* _tmp31_;
		GAppInfo* _tmp32_;
		GAppInfo* _tmp33_;
		GAppInfo* _tmp34_;
		const gchar* _tmp35_;
		GAppInfo* _tmp36_;
#line 114 "../src/Backend/App.vala"
		_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (match, SYNAPSE_TYPE_APPLICATION_MATCH, SynapseApplicationMatch));
#line 114 "../src/Backend/App.vala"
		app_match = _tmp29_;
#line 116 "../src/Backend/App.vala"
		_tmp30_ = app_match;
#line 116 "../src/Backend/App.vala"
		_tmp31_ = synapse_application_match_get_app_info (_tmp30_);
#line 116 "../src/Backend/App.vala"
		_tmp32_ = _tmp31_;
#line 116 "../src/Backend/App.vala"
		_tmp33_ = _g_object_ref0 (_tmp32_);
#line 116 "../src/Backend/App.vala"
		app_info = _tmp33_;
#line 118 "../src/Backend/App.vala"
		_tmp34_ = app_info;
#line 118 "../src/Backend/App.vala"
		_tmp35_ = g_app_info_get_id (_tmp34_);
#line 118 "../src/Backend/App.vala"
		slingshot_backend_app_set_desktop_id (self, _tmp35_);
#line 120 "../src/Backend/App.vala"
		_tmp36_ = app_info;
#line 120 "../src/Backend/App.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, G_TYPE_DESKTOP_APP_INFO)) {
#line 567 "App.c"
			GDesktopAppInfo* desktop_app_info = NULL;
			GAppInfo* _tmp37_;
			GDesktopAppInfo* _tmp38_;
			GDesktopAppInfo* _tmp39_;
			const gchar* _tmp40_;
			GDesktopAppInfo* _tmp41_;
#line 121 "../src/Backend/App.vala"
			_tmp37_ = app_info;
#line 121 "../src/Backend/App.vala"
			_tmp38_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, G_TYPE_DESKTOP_APP_INFO, GDesktopAppInfo));
#line 121 "../src/Backend/App.vala"
			desktop_app_info = _tmp38_;
#line 122 "../src/Backend/App.vala"
			_tmp39_ = desktop_app_info;
#line 122 "../src/Backend/App.vala"
			_tmp40_ = g_desktop_app_info_get_filename (_tmp39_);
#line 122 "../src/Backend/App.vala"
			slingshot_backend_app_set_desktop_path (self, _tmp40_);
#line 123 "../src/Backend/App.vala"
			_tmp41_ = desktop_app_info;
#line 123 "../src/Backend/App.vala"
			slingshot_backend_app_set_prefers_default_gpu (self, !g_desktop_app_info_get_boolean (_tmp41_, "PrefersNonDefaultGPU"));
#line 120 "../src/Backend/App.vala"
			_g_object_unref0 (desktop_app_info);
#line 592 "App.c"
		}
#line 112 "../src/Backend/App.vala"
		_g_object_unref0 (app_info);
#line 112 "../src/Backend/App.vala"
		_g_object_unref0 (app_match);
#line 598 "App.c"
	}
#line 127 "../src/Backend/App.vala"
	slingshot_backend_app_set_match (self, match);
#line 128 "../src/Backend/App.vala"
	slingshot_backend_app_set_target (self, target);
#line 94 "../src/Backend/App.vala"
	return self;
#line 606 "App.c"
}

SlingshotBackendApp*
slingshot_backend_app_new_from_synapse_match (SynapseMatch* match,
                                              SynapseMatch* target)
{
#line 94 "../src/Backend/App.vala"
	return slingshot_backend_app_construct_from_synapse_match (SLINGSHOT_BACKEND_TYPE_APP, match, target);
#line 615 "App.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 628 "App.c"
}

gboolean
slingshot_backend_app_launch (SlingshotBackendApp* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 131 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 638 "App.c"
	{
		SlingshotBackendAppAppType _tmp0_;
#line 133 "../src/Backend/App.vala"
		_tmp0_ = self->priv->_app_type;
#line 133 "../src/Backend/App.vala"
		switch (_tmp0_) {
#line 133 "../src/Backend/App.vala"
			case SLINGSHOT_BACKEND_APP_APP_TYPE_COMMAND:
#line 647 "App.c"
			{
				const gchar* _tmp1_;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				const gchar* _tmp5_;
#line 135 "../src/Backend/App.vala"
				_tmp1_ = self->priv->_name;
#line 135 "../src/Backend/App.vala"
				_tmp2_ = string_to_string (_tmp1_);
#line 135 "../src/Backend/App.vala"
				_tmp3_ = g_strconcat ("Launching command: ", _tmp2_, NULL);
#line 135 "../src/Backend/App.vala"
				_tmp4_ = _tmp3_;
#line 135 "../src/Backend/App.vala"
				g_debug ("App.vala:135: %s", _tmp4_);
#line 135 "../src/Backend/App.vala"
				_g_free0 (_tmp4_);
#line 136 "../src/Backend/App.vala"
				_tmp5_ = self->priv->_exec;
#line 136 "../src/Backend/App.vala"
				g_spawn_command_line_async (_tmp5_, &_inner_error0_);
#line 136 "../src/Backend/App.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 672 "App.c"
					goto __catch0_g_error;
				}
#line 137 "../src/Backend/App.vala"
				break;
#line 677 "App.c"
			}
#line 133 "../src/Backend/App.vala"
			case SLINGSHOT_BACKEND_APP_APP_TYPE_APP:
#line 681 "App.c"
			{
				GdkAppLaunchContext* context = NULL;
				GdkDisplay* _tmp6_;
				GdkAppLaunchContext* _tmp7_;
				GdkAppLaunchContext* _tmp8_;
				SlingshotBackendSwitcherooControl* _tmp9_;
				GdkAppLaunchContext* _tmp10_;
				gboolean _tmp11_;
				const gchar* _tmp12_;
				GDesktopAppInfo* _tmp13_;
				GDesktopAppInfo* _tmp14_;
				GdkAppLaunchContext* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 139 "../src/Backend/App.vala"
				g_signal_emit (self, slingshot_backend_app_signals[SLINGSHOT_BACKEND_APP_LAUNCHED_SIGNAL], 0, self);
#line 141 "../src/Backend/App.vala"
				_tmp6_ = gdk_display_get_default ();
#line 141 "../src/Backend/App.vala"
				_tmp7_ = gdk_display_get_app_launch_context (_tmp6_);
#line 141 "../src/Backend/App.vala"
				context = _tmp7_;
#line 142 "../src/Backend/App.vala"
				_tmp8_ = context;
#line 142 "../src/Backend/App.vala"
				gdk_app_launch_context_set_timestamp (_tmp8_, gtk_get_current_event_time ());
#line 143 "../src/Backend/App.vala"
				_tmp9_ = self->priv->switcheroo_control;
#line 143 "../src/Backend/App.vala"
				_tmp10_ = context;
#line 143 "../src/Backend/App.vala"
				_tmp11_ = self->priv->_prefers_default_gpu;
#line 143 "../src/Backend/App.vala"
				slingshot_backend_switcheroo_control_apply_gpu_environment (_tmp9_, (GAppLaunchContext*) _tmp10_, _tmp11_);
#line 145 "../src/Backend/App.vala"
				_tmp12_ = self->priv->_desktop_id;
#line 145 "../src/Backend/App.vala"
				_tmp13_ = g_desktop_app_info_new (_tmp12_);
#line 145 "../src/Backend/App.vala"
				_tmp14_ = _tmp13_;
#line 145 "../src/Backend/App.vala"
				_tmp15_ = context;
#line 145 "../src/Backend/App.vala"
				g_app_info_launch ((GAppInfo*) _tmp14_, NULL, (GAppLaunchContext*) _tmp15_, &_inner_error0_);
#line 145 "../src/Backend/App.vala"
				_g_object_unref0 (_tmp14_);
#line 145 "../src/Backend/App.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "../src/Backend/App.vala"
					_g_object_unref0 (context);
#line 734 "App.c"
					goto __catch0_g_error;
				}
#line 147 "../src/Backend/App.vala"
				_tmp16_ = self->priv->_name;
#line 147 "../src/Backend/App.vala"
				_tmp17_ = string_to_string (_tmp16_);
#line 147 "../src/Backend/App.vala"
				_tmp18_ = g_strconcat ("Launching application: ", _tmp17_, NULL);
#line 147 "../src/Backend/App.vala"
				_tmp19_ = _tmp18_;
#line 147 "../src/Backend/App.vala"
				g_debug ("App.vala:147: %s", _tmp19_);
#line 147 "../src/Backend/App.vala"
				_g_free0 (_tmp19_);
#line 148 "../src/Backend/App.vala"
				_g_object_unref0 (context);
#line 148 "../src/Backend/App.vala"
				break;
#line 753 "App.c"
			}
#line 133 "../src/Backend/App.vala"
			case SLINGSHOT_BACKEND_APP_APP_TYPE_SYNAPSE:
#line 757 "App.c"
			{
				SynapseMatch* _tmp20_;
				SynapseMatchType _tmp21_;
				SynapseMatchType _tmp22_;
#line 150 "../src/Backend/App.vala"
				_tmp20_ = self->priv->_match;
#line 150 "../src/Backend/App.vala"
				_tmp21_ = synapse_match_get_match_type (_tmp20_);
#line 150 "../src/Backend/App.vala"
				_tmp22_ = _tmp21_;
#line 150 "../src/Backend/App.vala"
				if (_tmp22_ == SYNAPSE_MATCH_TYPE_SEARCH) {
#line 770 "App.c"
					SynapseMatch* _tmp23_;
					SynapseMatch* _tmp24_;
#line 151 "../src/Backend/App.vala"
					_tmp23_ = self->priv->_match;
#line 151 "../src/Backend/App.vala"
					_tmp24_ = self->priv->_target;
#line 151 "../src/Backend/App.vala"
					g_signal_emit (self, slingshot_backend_app_signals[SLINGSHOT_BACKEND_APP_START_SEARCH_SIGNAL], 0, SYNAPSE_IS_SEARCH_MATCH (_tmp23_) ? ((SynapseSearchMatch*) _tmp23_) : NULL, _tmp24_);
#line 152 "../src/Backend/App.vala"
					result = FALSE;
#line 152 "../src/Backend/App.vala"
					return result;
#line 783 "App.c"
				} else {
					SynapseMatch* _tmp25_;
#line 154 "../src/Backend/App.vala"
					_tmp25_ = self->priv->_target;
#line 154 "../src/Backend/App.vala"
					if (_tmp25_ == NULL) {
#line 790 "App.c"
						SynapseMatch* _tmp26_;
						GeeList* _tmp27_;
						GeeList* _tmp28_;
						gpointer _tmp29_;
						SynapseMatch* _tmp30_;
						SynapseMatch* _tmp31_;
#line 155 "../src/Backend/App.vala"
						_tmp26_ = self->priv->_match;
#line 155 "../src/Backend/App.vala"
						_tmp27_ = slingshot_backend_synapse_search_find_actions_for_match (_tmp26_);
#line 155 "../src/Backend/App.vala"
						_tmp28_ = _tmp27_;
#line 155 "../src/Backend/App.vala"
						_tmp29_ = gee_list_get (_tmp28_, 0);
#line 155 "../src/Backend/App.vala"
						_tmp30_ = (SynapseMatch*) _tmp29_;
#line 155 "../src/Backend/App.vala"
						_tmp31_ = self->priv->_match;
#line 155 "../src/Backend/App.vala"
						synapse_match_execute_with_target (_tmp30_, _tmp31_, NULL);
#line 155 "../src/Backend/App.vala"
						_g_object_unref0 (_tmp30_);
#line 155 "../src/Backend/App.vala"
						_g_object_unref0 (_tmp28_);
#line 815 "App.c"
					} else {
						SynapseMatch* _tmp32_;
						SynapseMatch* _tmp33_;
#line 157 "../src/Backend/App.vala"
						_tmp32_ = self->priv->_match;
#line 157 "../src/Backend/App.vala"
						_tmp33_ = self->priv->_target;
#line 157 "../src/Backend/App.vala"
						synapse_match_execute_with_target (_tmp32_, _tmp33_, NULL);
#line 825 "App.c"
					}
				}
#line 159 "../src/Backend/App.vala"
				break;
#line 830 "App.c"
			}
			default:
#line 133 "../src/Backend/App.vala"
			break;
#line 835 "App.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp34_;
		const gchar* _tmp35_;
#line 132 "../src/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 162 "../src/Backend/App.vala"
		_tmp34_ = self->priv->_name;
#line 162 "../src/Backend/App.vala"
		_tmp35_ = self->priv->_exec;
#line 162 "../src/Backend/App.vala"
		g_warning ("App.vala:162: Failed to launch %s: %s", _tmp34_, _tmp35_);
#line 851 "App.c"
	}
	__finally0:
#line 132 "../src/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 856 "App.c"
		gboolean _tmp36_ = FALSE;
#line 132 "../src/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 132 "../src/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 132 "../src/Backend/App.vala"
		return _tmp36_;
#line 864 "App.c"
	}
#line 165 "../src/Backend/App.vala"
	result = TRUE;
#line 165 "../src/Backend/App.vala"
	return result;
#line 870 "App.c"
}

void
slingshot_backend_app_perform_unity_update (SlingshotBackendApp* self,
                                            const gchar* sender_name,
                                            GVariantIter* prop_iter)
{
	gchar* _tmp0_;
	gchar* prop_key = NULL;
	GVariant* prop_value = NULL;
#line 169 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/Backend/App.vala"
	g_return_if_fail (sender_name != NULL);
#line 169 "../src/Backend/App.vala"
	g_return_if_fail (prop_iter != NULL);
#line 170 "../src/Backend/App.vala"
	_tmp0_ = g_strdup (sender_name);
#line 170 "../src/Backend/App.vala"
	_g_free0 (self->priv->unity_sender_name);
#line 170 "../src/Backend/App.vala"
	self->priv->unity_sender_name = _tmp0_;
#line 174 "../src/Backend/App.vala"
	while (TRUE) {
#line 895 "App.c"
		gchar* _tmp1_ = NULL;
		GVariant* _tmp2_ = NULL;
		gboolean _tmp3_;
		const gchar* _tmp4_;
#line 174 "../src/Backend/App.vala"
		_tmp3_ = g_variant_iter_next (prop_iter, "{sv}", &_tmp1_, &_tmp2_, NULL);
#line 174 "../src/Backend/App.vala"
		_g_free0 (prop_key);
#line 174 "../src/Backend/App.vala"
		prop_key = _tmp1_;
#line 174 "../src/Backend/App.vala"
		_g_variant_unref0 (prop_value);
#line 174 "../src/Backend/App.vala"
		prop_value = _tmp2_;
#line 174 "../src/Backend/App.vala"
		if (!_tmp3_) {
#line 174 "../src/Backend/App.vala"
			break;
#line 914 "App.c"
		}
#line 175 "../src/Backend/App.vala"
		_tmp4_ = prop_key;
#line 175 "../src/Backend/App.vala"
		if (g_strcmp0 (_tmp4_, "count") == 0) {
#line 920 "App.c"
			GVariant* _tmp5_;
#line 176 "../src/Backend/App.vala"
			_tmp5_ = prop_value;
#line 176 "../src/Backend/App.vala"
			slingshot_backend_app_set_current_count (self, g_variant_get_int64 (_tmp5_));
#line 926 "App.c"
		} else {
			const gchar* _tmp6_;
#line 177 "../src/Backend/App.vala"
			_tmp6_ = prop_key;
#line 177 "../src/Backend/App.vala"
			if (g_strcmp0 (_tmp6_, "count-visible") == 0) {
#line 933 "App.c"
				GVariant* _tmp7_;
#line 178 "../src/Backend/App.vala"
				_tmp7_ = prop_value;
#line 178 "../src/Backend/App.vala"
				slingshot_backend_app_set_count_visible (self, g_variant_get_boolean (_tmp7_));
#line 939 "App.c"
			}
		}
	}
#line 169 "../src/Backend/App.vala"
	_g_variant_unref0 (prop_value);
#line 169 "../src/Backend/App.vala"
	_g_free0 (prop_key);
#line 947 "App.c"
}

void
slingshot_backend_app_remove_launcher_entry (SlingshotBackendApp* self,
                                             const gchar* sender_name)
{
	const gchar* _tmp0_;
#line 183 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/Backend/App.vala"
	g_return_if_fail (sender_name != NULL);
#line 184 "../src/Backend/App.vala"
	_tmp0_ = self->priv->unity_sender_name;
#line 184 "../src/Backend/App.vala"
	if (g_strcmp0 (_tmp0_, sender_name) == 0) {
#line 185 "../src/Backend/App.vala"
		_g_free0 (self->priv->unity_sender_name);
#line 185 "../src/Backend/App.vala"
		self->priv->unity_sender_name = NULL;
#line 186 "../src/Backend/App.vala"
		slingshot_backend_app_set_count_visible (self, FALSE);
#line 187 "../src/Backend/App.vala"
		slingshot_backend_app_set_current_count (self, (gint64) 0);
#line 971 "App.c"
	}
}

const gchar*
slingshot_backend_app_get_name (SlingshotBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_name;
#line 31 "../src/Backend/App.vala"
	result = _tmp0_;
#line 31 "../src/Backend/App.vala"
	return result;
#line 988 "App.c"
}

void
slingshot_backend_app_set_name (SlingshotBackendApp* self,
                                const gchar* value)
{
	gchar* old_value;
#line 31 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_name (self);
#line 31 "../src/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1002 "App.c"
		gchar* _tmp0_;
#line 31 "../src/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/Backend/App.vala"
		_g_free0 (self->priv->_name);
#line 31 "../src/Backend/App.vala"
		self->priv->_name = _tmp0_;
#line 31 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_NAME_PROPERTY]);
#line 1012 "App.c"
	}
}

const gchar*
slingshot_backend_app_get_description (SlingshotBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_description;
#line 32 "../src/Backend/App.vala"
	result = _tmp0_;
#line 32 "../src/Backend/App.vala"
	return result;
#line 1029 "App.c"
}

static void
slingshot_backend_app_set_description (SlingshotBackendApp* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 32 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_description (self);
#line 32 "../src/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1043 "App.c"
		gchar* _tmp0_;
#line 32 "../src/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/Backend/App.vala"
		_g_free0 (self->priv->_description);
#line 32 "../src/Backend/App.vala"
		self->priv->_description = _tmp0_;
#line 32 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_DESCRIPTION_PROPERTY]);
#line 1053 "App.c"
	}
}

const gchar*
slingshot_backend_app_get_desktop_id (SlingshotBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_desktop_id;
#line 33 "../src/Backend/App.vala"
	result = _tmp0_;
#line 33 "../src/Backend/App.vala"
	return result;
#line 1070 "App.c"
}

void
slingshot_backend_app_set_desktop_id (SlingshotBackendApp* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 33 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_desktop_id (self);
#line 33 "../src/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1084 "App.c"
		gchar* _tmp0_;
#line 33 "../src/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/Backend/App.vala"
		_g_free0 (self->priv->_desktop_id);
#line 33 "../src/Backend/App.vala"
		self->priv->_desktop_id = _tmp0_;
#line 33 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_DESKTOP_ID_PROPERTY]);
#line 1094 "App.c"
	}
}

const gchar*
slingshot_backend_app_get_exec (SlingshotBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_exec;
#line 34 "../src/Backend/App.vala"
	result = _tmp0_;
#line 34 "../src/Backend/App.vala"
	return result;
#line 1111 "App.c"
}

static void
slingshot_backend_app_set_exec (SlingshotBackendApp* self,
                                const gchar* value)
{
	gchar* old_value;
#line 34 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_exec (self);
#line 34 "../src/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1125 "App.c"
		gchar* _tmp0_;
#line 34 "../src/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/Backend/App.vala"
		_g_free0 (self->priv->_exec);
#line 34 "../src/Backend/App.vala"
		self->priv->_exec = _tmp0_;
#line 34 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_EXEC_PROPERTY]);
#line 1135 "App.c"
	}
}

gchar**
slingshot_backend_app_get_keywords (SlingshotBackendApp* self,
                                    gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 35 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_keywords;
#line 35 "../src/Backend/App.vala"
	_tmp0__length1 = self->priv->_keywords_length1;
#line 35 "../src/Backend/App.vala"
	_tmp1_ = _tmp0_;
#line 35 "../src/Backend/App.vala"
	_tmp1__length1 = _tmp0__length1;
#line 35 "../src/Backend/App.vala"
	if (result_length1) {
#line 35 "../src/Backend/App.vala"
		*result_length1 = _tmp1__length1;
#line 1162 "App.c"
	}
#line 35 "../src/Backend/App.vala"
	result = _tmp1_;
#line 35 "../src/Backend/App.vala"
	return result;
#line 1168 "App.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 35 "../src/Backend/App.vala"
	if (length >= 0) {
#line 1177 "App.c"
		gchar** result;
		gssize i;
#line 35 "../src/Backend/App.vala"
		result = g_new0 (gchar*, length + 1);
#line 35 "../src/Backend/App.vala"
		for (i = 0; i < length; i++) {
#line 1184 "App.c"
			gchar* _tmp0_;
#line 35 "../src/Backend/App.vala"
			_tmp0_ = g_strdup (self[i]);
#line 35 "../src/Backend/App.vala"
			result[i] = _tmp0_;
#line 1190 "App.c"
		}
#line 35 "../src/Backend/App.vala"
		return result;
#line 1194 "App.c"
	}
#line 35 "../src/Backend/App.vala"
	return NULL;
#line 1198 "App.c"
}

static void
slingshot_backend_app_set_keywords (SlingshotBackendApp* self,
                                    gchar** value,
                                    gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 35 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_keywords (self, &old_value_length);
#line 35 "../src/Backend/App.vala"
	if (old_value != value) {
#line 1214 "App.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 35 "../src/Backend/App.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : value;
#line 35 "../src/Backend/App.vala"
		_tmp0__length1 = value_length1;
#line 35 "../src/Backend/App.vala"
		self->priv->_keywords = (_vala_array_free (self->priv->_keywords, self->priv->_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 35 "../src/Backend/App.vala"
		self->priv->_keywords = _tmp0_;
#line 35 "../src/Backend/App.vala"
		self->priv->_keywords_length1 = _tmp0__length1;
#line 35 "../src/Backend/App.vala"
		self->priv->__keywords_size_ = self->priv->_keywords_length1;
#line 35 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_KEYWORDS_PROPERTY]);
#line 1231 "App.c"
	}
}

GIcon*
slingshot_backend_app_get_icon (SlingshotBackendApp* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 36 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_icon;
#line 36 "../src/Backend/App.vala"
	result = _tmp0_;
#line 36 "../src/Backend/App.vala"
	return result;
#line 1248 "App.c"
}

static void
slingshot_backend_app_set_icon (SlingshotBackendApp* self,
                                GIcon* value)
{
	GIcon* old_value;
#line 36 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_icon (self);
#line 36 "../src/Backend/App.vala"
	if (old_value != value) {
#line 1262 "App.c"
		GIcon* _tmp0_;
#line 36 "../src/Backend/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 36 "../src/Backend/App.vala"
		_g_object_unref0 (self->priv->_icon);
#line 36 "../src/Backend/App.vala"
		self->priv->_icon = _tmp0_;
#line 36 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_ICON_PROPERTY]);
#line 1272 "App.c"
	}
}

gdouble
slingshot_backend_app_get_popularity (SlingshotBackendApp* self)
{
	gdouble result;
#line 37 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 37 "../src/Backend/App.vala"
	result = self->priv->_popularity;
#line 37 "../src/Backend/App.vala"
	return result;
#line 1286 "App.c"
}

void
slingshot_backend_app_set_popularity (SlingshotBackendApp* self,
                                      gdouble value)
{
	gdouble old_value;
#line 37 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_popularity (self);
#line 37 "../src/Backend/App.vala"
	if (old_value != value) {
#line 37 "../src/Backend/App.vala"
		self->priv->_popularity = value;
#line 37 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_POPULARITY_PROPERTY]);
#line 1304 "App.c"
	}
}

const gchar*
slingshot_backend_app_get_desktop_path (SlingshotBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_desktop_path;
#line 38 "../src/Backend/App.vala"
	result = _tmp0_;
#line 38 "../src/Backend/App.vala"
	return result;
#line 1321 "App.c"
}

static void
slingshot_backend_app_set_desktop_path (SlingshotBackendApp* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 38 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_desktop_path (self);
#line 38 "../src/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1335 "App.c"
		gchar* _tmp0_;
#line 38 "../src/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 38 "../src/Backend/App.vala"
		_g_free0 (self->priv->_desktop_path);
#line 38 "../src/Backend/App.vala"
		self->priv->_desktop_path = _tmp0_;
#line 38 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_DESKTOP_PATH_PROPERTY]);
#line 1345 "App.c"
	}
}

const gchar*
slingshot_backend_app_get_categories (SlingshotBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_categories;
#line 39 "../src/Backend/App.vala"
	result = _tmp0_;
#line 39 "../src/Backend/App.vala"
	return result;
#line 1362 "App.c"
}

static void
slingshot_backend_app_set_categories (SlingshotBackendApp* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 39 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_categories (self);
#line 39 "../src/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1376 "App.c"
		gchar* _tmp0_;
#line 39 "../src/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 39 "../src/Backend/App.vala"
		_g_free0 (self->priv->_categories);
#line 39 "../src/Backend/App.vala"
		self->priv->_categories = _tmp0_;
#line 39 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_CATEGORIES_PROPERTY]);
#line 1386 "App.c"
	}
}

const gchar*
slingshot_backend_app_get_generic_name (SlingshotBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_generic_name;
#line 40 "../src/Backend/App.vala"
	result = _tmp0_;
#line 40 "../src/Backend/App.vala"
	return result;
#line 1403 "App.c"
}

static void
slingshot_backend_app_set_generic_name (SlingshotBackendApp* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 40 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_generic_name (self);
#line 40 "../src/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1417 "App.c"
		gchar* _tmp0_;
#line 40 "../src/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 40 "../src/Backend/App.vala"
		_g_free0 (self->priv->_generic_name);
#line 40 "../src/Backend/App.vala"
		self->priv->_generic_name = _tmp0_;
#line 40 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_GENERIC_NAME_PROPERTY]);
#line 1427 "App.c"
	}
}

gboolean
slingshot_backend_app_get_prefers_default_gpu (SlingshotBackendApp* self)
{
	gboolean result;
#line 41 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/Backend/App.vala"
	result = self->priv->_prefers_default_gpu;
#line 41 "../src/Backend/App.vala"
	return result;
#line 1441 "App.c"
}

static void
slingshot_backend_app_set_prefers_default_gpu (SlingshotBackendApp* self,
                                               gboolean value)
{
	gboolean old_value;
#line 41 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_prefers_default_gpu (self);
#line 41 "../src/Backend/App.vala"
	if (old_value != value) {
#line 41 "../src/Backend/App.vala"
		self->priv->_prefers_default_gpu = value;
#line 41 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_PREFERS_DEFAULT_GPU_PROPERTY]);
#line 1459 "App.c"
	}
}

SlingshotBackendAppAppType
slingshot_backend_app_get_app_type (SlingshotBackendApp* self)
{
	SlingshotBackendAppAppType result;
#line 42 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/Backend/App.vala"
	result = self->priv->_app_type;
#line 42 "../src/Backend/App.vala"
	return result;
#line 1473 "App.c"
}

static void
slingshot_backend_app_set_app_type (SlingshotBackendApp* self,
                                    SlingshotBackendAppAppType value)
{
	SlingshotBackendAppAppType old_value;
#line 42 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_app_type (self);
#line 42 "../src/Backend/App.vala"
	if (old_value != value) {
#line 42 "../src/Backend/App.vala"
		self->priv->_app_type = value;
#line 42 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_APP_TYPE_PROPERTY]);
#line 1491 "App.c"
	}
}

gboolean
slingshot_backend_app_get_count_visible (SlingshotBackendApp* self)
{
	gboolean result;
#line 46 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../src/Backend/App.vala"
	result = self->priv->_count_visible;
#line 46 "../src/Backend/App.vala"
	return result;
#line 1505 "App.c"
}

static void
slingshot_backend_app_set_count_visible (SlingshotBackendApp* self,
                                         gboolean value)
{
	gboolean old_value;
#line 46 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_count_visible (self);
#line 46 "../src/Backend/App.vala"
	if (old_value != value) {
#line 46 "../src/Backend/App.vala"
		self->priv->_count_visible = value;
#line 46 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_COUNT_VISIBLE_PROPERTY]);
#line 1523 "App.c"
	}
}

gint64
slingshot_backend_app_get_current_count (SlingshotBackendApp* self)
{
	gint64 result;
#line 47 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 47 "../src/Backend/App.vala"
	result = self->priv->_current_count;
#line 47 "../src/Backend/App.vala"
	return result;
#line 1537 "App.c"
}

static void
slingshot_backend_app_set_current_count (SlingshotBackendApp* self,
                                         gint64 value)
{
	gint64 old_value;
#line 47 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_current_count (self);
#line 47 "../src/Backend/App.vala"
	if (old_value != value) {
#line 47 "../src/Backend/App.vala"
		self->priv->_current_count = value;
#line 47 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_CURRENT_COUNT_PROPERTY]);
#line 1555 "App.c"
	}
}

SynapseMatch*
slingshot_backend_app_get_match (SlingshotBackendApp* self)
{
	SynapseMatch* result;
	SynapseMatch* _tmp0_;
#line 50 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_match;
#line 50 "../src/Backend/App.vala"
	result = _tmp0_;
#line 50 "../src/Backend/App.vala"
	return result;
#line 1572 "App.c"
}

static void
slingshot_backend_app_set_match (SlingshotBackendApp* self,
                                 SynapseMatch* value)
{
	SynapseMatch* old_value;
#line 50 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_match (self);
#line 50 "../src/Backend/App.vala"
	if (old_value != value) {
#line 1586 "App.c"
		SynapseMatch* _tmp0_;
#line 50 "../src/Backend/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../src/Backend/App.vala"
		_g_object_unref0 (self->priv->_match);
#line 50 "../src/Backend/App.vala"
		self->priv->_match = _tmp0_;
#line 50 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_MATCH_PROPERTY]);
#line 1596 "App.c"
	}
}

SynapseMatch*
slingshot_backend_app_get_target (SlingshotBackendApp* self)
{
	SynapseMatch* result;
	SynapseMatch* _tmp0_;
#line 51 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_target;
#line 51 "../src/Backend/App.vala"
	result = _tmp0_;
#line 51 "../src/Backend/App.vala"
	return result;
#line 1613 "App.c"
}

static void
slingshot_backend_app_set_target (SlingshotBackendApp* self,
                                  SynapseMatch* value)
{
	SynapseMatch* old_value;
#line 51 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Backend/App.vala"
	old_value = slingshot_backend_app_get_target (self);
#line 51 "../src/Backend/App.vala"
	if (old_value != value) {
#line 1627 "App.c"
		SynapseMatch* _tmp0_;
#line 51 "../src/Backend/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 51 "../src/Backend/App.vala"
		_g_object_unref0 (self->priv->_target);
#line 51 "../src/Backend/App.vala"
		self->priv->_target = _tmp0_;
#line 51 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_TARGET_PROPERTY]);
#line 1637 "App.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 21 "../src/Backend/App.vala"
	g_return_if_fail (n_param_values == 3);
#line 21 "../src/Backend/App.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 21 "../src/Backend/App.vala"
		data1 = closure->data;
#line 21 "../src/Backend/App.vala"
		data2 = param_values->data[0].v_pointer;
#line 1663 "App.c"
	} else {
#line 21 "../src/Backend/App.vala"
		data1 = param_values->data[0].v_pointer;
#line 21 "../src/Backend/App.vala"
		data2 = closure->data;
#line 1669 "App.c"
	}
#line 21 "../src/Backend/App.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 21 "../src/Backend/App.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1675 "App.c"
}

static GObject *
slingshot_backend_app_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotBackendApp * self;
	SlingshotBackendSwitcherooControl* _tmp0_;
#line 55 "../src/Backend/App.vala"
	parent_class = G_OBJECT_CLASS (slingshot_backend_app_parent_class);
#line 55 "../src/Backend/App.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 55 "../src/Backend/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_BACKEND_TYPE_APP, SlingshotBackendApp);
#line 56 "../src/Backend/App.vala"
	_tmp0_ = slingshot_backend_switcheroo_control_new ();
#line 56 "../src/Backend/App.vala"
	_g_object_unref0 (self->priv->switcheroo_control);
#line 56 "../src/Backend/App.vala"
	self->priv->switcheroo_control = _tmp0_;
#line 55 "../src/Backend/App.vala"
	return obj;
#line 1701 "App.c"
}

static void
slingshot_backend_app_class_init (SlingshotBackendAppClass * klass,
                                  gpointer klass_data)
{
#line 21 "../src/Backend/App.vala"
	slingshot_backend_app_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Backend/App.vala"
	g_type_class_adjust_private_offset (klass, &SlingshotBackendApp_private_offset);
#line 21 "../src/Backend/App.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slingshot_backend_app_get_property;
#line 21 "../src/Backend/App.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slingshot_backend_app_set_property;
#line 21 "../src/Backend/App.vala"
	G_OBJECT_CLASS (klass)->constructor = slingshot_backend_app_constructor;
#line 21 "../src/Backend/App.vala"
	G_OBJECT_CLASS (klass)->finalize = slingshot_backend_app_finalize;
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_NAME_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_DESCRIPTION_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_DESKTOP_ID_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_DESKTOP_ID_PROPERTY] = g_param_spec_string ("desktop-id", "desktop-id", "desktop-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_EXEC_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_EXEC_PROPERTY] = g_param_spec_string ("exec", "exec", "exec", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_KEYWORDS_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_KEYWORDS_PROPERTY] = g_param_spec_boxed ("keywords", "keywords", "keywords", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_ICON_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_POPULARITY_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_POPULARITY_PROPERTY] = g_param_spec_double ("popularity", "popularity", "popularity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_DESKTOP_PATH_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_DESKTOP_PATH_PROPERTY] = g_param_spec_string ("desktop-path", "desktop-path", "desktop-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_CATEGORIES_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_CATEGORIES_PROPERTY] = g_param_spec_string ("categories", "categories", "categories", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_GENERIC_NAME_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_GENERIC_NAME_PROPERTY] = g_param_spec_string ("generic-name", "generic-name", "generic-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_PREFERS_DEFAULT_GPU_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_PREFERS_DEFAULT_GPU_PROPERTY] = g_param_spec_boolean ("prefers-default-gpu", "prefers-default-gpu", "prefers-default-gpu", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_APP_TYPE_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_APP_TYPE_PROPERTY] = g_param_spec_enum ("app-type", "app-type", "app-type", SLINGSHOT_BACKEND_APP_TYPE_APP_TYPE, SLINGSHOT_BACKEND_APP_APP_TYPE_APP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_COUNT_VISIBLE_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_COUNT_VISIBLE_PROPERTY] = g_param_spec_boolean ("count-visible", "count-visible", "count-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_CURRENT_COUNT_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_CURRENT_COUNT_PROPERTY] = g_param_spec_int64 ("current-count", "current-count", "current-count", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_MATCH_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_MATCH_PROPERTY] = g_param_spec_object ("match", "match", "match", SYNAPSE_TYPE_MATCH, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_TARGET_PROPERTY, slingshot_backend_app_properties[SLINGSHOT_BACKEND_APP_TARGET_PROPERTY] = g_param_spec_object ("target", "target", "target", SYNAPSE_TYPE_MATCH, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Backend/App.vala"
	slingshot_backend_app_signals[SLINGSHOT_BACKEND_APP_LAUNCHED_SIGNAL] = g_signal_new ("launched", SLINGSHOT_BACKEND_TYPE_APP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SLINGSHOT_BACKEND_TYPE_APP);
#line 21 "../src/Backend/App.vala"
	slingshot_backend_app_signals[SLINGSHOT_BACKEND_APP_START_SEARCH_SIGNAL] = g_signal_new ("start-search", SLINGSHOT_BACKEND_TYPE_APP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, SYNAPSE_TYPE_SEARCH_MATCH, SYNAPSE_TYPE_MATCH);
#line 1756 "App.c"
}

static void
slingshot_backend_app_instance_init (SlingshotBackendApp * self,
                                     gpointer klass)
{
	gchar* _tmp0_;
	GThemedIcon* _tmp1_;
	gchar* _tmp2_;
#line 21 "../src/Backend/App.vala"
	self->priv = slingshot_backend_app_get_instance_private (self);
#line 32 "../src/Backend/App.vala"
	_tmp0_ = g_strdup ("");
#line 32 "../src/Backend/App.vala"
	self->priv->_description = _tmp0_;
#line 36 "../src/Backend/App.vala"
	_tmp1_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 36 "../src/Backend/App.vala"
	self->priv->_icon = (GIcon*) _tmp1_;
#line 40 "../src/Backend/App.vala"
	_tmp2_ = g_strdup ("");
#line 40 "../src/Backend/App.vala"
	self->priv->_generic_name = _tmp2_;
#line 41 "../src/Backend/App.vala"
	self->priv->_prefers_default_gpu = FALSE;
#line 42 "../src/Backend/App.vala"
	self->priv->_app_type = SLINGSHOT_BACKEND_APP_APP_TYPE_APP;
#line 45 "../src/Backend/App.vala"
	self->priv->unity_sender_name = NULL;
#line 46 "../src/Backend/App.vala"
	self->priv->_count_visible = FALSE;
#line 47 "../src/Backend/App.vala"
	self->priv->_current_count = (gint64) 0;
#line 50 "../src/Backend/App.vala"
	self->priv->_match = NULL;
#line 51 "../src/Backend/App.vala"
	self->priv->_target = NULL;
#line 1794 "App.c"
}

static void
slingshot_backend_app_finalize (GObject * obj)
{
	SlingshotBackendApp * self;
#line 21 "../src/Backend/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_BACKEND_TYPE_APP, SlingshotBackendApp);
#line 31 "../src/Backend/App.vala"
	_g_free0 (self->priv->_name);
#line 32 "../src/Backend/App.vala"
	_g_free0 (self->priv->_description);
#line 33 "../src/Backend/App.vala"
	_g_free0 (self->priv->_desktop_id);
#line 34 "../src/Backend/App.vala"
	_g_free0 (self->priv->_exec);
#line 35 "../src/Backend/App.vala"
	self->priv->_keywords = (_vala_array_free (self->priv->_keywords, self->priv->_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 36 "../src/Backend/App.vala"
	_g_object_unref0 (self->priv->_icon);
#line 38 "../src/Backend/App.vala"
	_g_free0 (self->priv->_desktop_path);
#line 39 "../src/Backend/App.vala"
	_g_free0 (self->priv->_categories);
#line 40 "../src/Backend/App.vala"
	_g_free0 (self->priv->_generic_name);
#line 45 "../src/Backend/App.vala"
	_g_free0 (self->priv->unity_sender_name);
#line 50 "../src/Backend/App.vala"
	_g_object_unref0 (self->priv->_match);
#line 51 "../src/Backend/App.vala"
	_g_object_unref0 (self->priv->_target);
#line 53 "../src/Backend/App.vala"
	_g_object_unref0 (self->priv->switcheroo_control);
#line 21 "../src/Backend/App.vala"
	G_OBJECT_CLASS (slingshot_backend_app_parent_class)->finalize (obj);
#line 1831 "App.c"
}

static GType
slingshot_backend_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotBackendAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_backend_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotBackendApp), 0, (GInstanceInitFunc) slingshot_backend_app_instance_init, NULL };
	GType slingshot_backend_app_type_id;
	slingshot_backend_app_type_id = g_type_register_static (G_TYPE_OBJECT, "SlingshotBackendApp", &g_define_type_info, 0);
	SlingshotBackendApp_private_offset = g_type_add_instance_private (slingshot_backend_app_type_id, sizeof (SlingshotBackendAppPrivate));
	return slingshot_backend_app_type_id;
}

GType
slingshot_backend_app_get_type (void)
{
	static volatile gsize slingshot_backend_app_type_id__once = 0;
	if (g_once_init_enter (&slingshot_backend_app_type_id__once)) {
		GType slingshot_backend_app_type_id;
		slingshot_backend_app_type_id = slingshot_backend_app_get_type_once ();
		g_once_init_leave (&slingshot_backend_app_type_id__once, slingshot_backend_app_type_id);
	}
	return slingshot_backend_app_type_id__once;
}

static void
_vala_slingshot_backend_app_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	SlingshotBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_BACKEND_TYPE_APP, SlingshotBackendApp);
#line 21 "../src/Backend/App.vala"
	switch (property_id) {
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_NAME_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_string (value, slingshot_backend_app_get_name (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_DESCRIPTION_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_string (value, slingshot_backend_app_get_description (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_DESKTOP_ID_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_string (value, slingshot_backend_app_get_desktop_id (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_EXEC_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_string (value, slingshot_backend_app_get_exec (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_KEYWORDS_PROPERTY:
#line 1892 "App.c"
		{
			int length;
#line 21 "../src/Backend/App.vala"
			g_value_set_boxed (value, slingshot_backend_app_get_keywords (self, &length));
#line 1897 "App.c"
		}
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_ICON_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_object (value, slingshot_backend_app_get_icon (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_POPULARITY_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_double (value, slingshot_backend_app_get_popularity (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_DESKTOP_PATH_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_string (value, slingshot_backend_app_get_desktop_path (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_CATEGORIES_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_string (value, slingshot_backend_app_get_categories (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_GENERIC_NAME_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_string (value, slingshot_backend_app_get_generic_name (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_PREFERS_DEFAULT_GPU_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_boolean (value, slingshot_backend_app_get_prefers_default_gpu (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_APP_TYPE_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_enum (value, slingshot_backend_app_get_app_type (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_COUNT_VISIBLE_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_boolean (value, slingshot_backend_app_get_count_visible (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_CURRENT_COUNT_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_int64 (value, slingshot_backend_app_get_current_count (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_MATCH_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_object (value, slingshot_backend_app_get_match (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_TARGET_PROPERTY:
#line 21 "../src/Backend/App.vala"
		g_value_set_object (value, slingshot_backend_app_get_target (self));
#line 21 "../src/Backend/App.vala"
		break;
#line 1967 "App.c"
		default:
#line 21 "../src/Backend/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Backend/App.vala"
		break;
#line 1973 "App.c"
	}
}

static void
_vala_slingshot_backend_app_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	SlingshotBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_BACKEND_TYPE_APP, SlingshotBackendApp);
#line 21 "../src/Backend/App.vala"
	switch (property_id) {
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_NAME_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_name (self, g_value_get_string (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_DESCRIPTION_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_description (self, g_value_get_string (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_DESKTOP_ID_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_desktop_id (self, g_value_get_string (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_EXEC_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_exec (self, g_value_get_string (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_KEYWORDS_PROPERTY:
#line 2013 "App.c"
		{
			gpointer boxed;
#line 21 "../src/Backend/App.vala"
			boxed = g_value_get_boxed (value);
#line 21 "../src/Backend/App.vala"
			slingshot_backend_app_set_keywords (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2020 "App.c"
		}
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_ICON_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_icon (self, g_value_get_object (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_POPULARITY_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_popularity (self, g_value_get_double (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_DESKTOP_PATH_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_desktop_path (self, g_value_get_string (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_CATEGORIES_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_categories (self, g_value_get_string (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_GENERIC_NAME_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_generic_name (self, g_value_get_string (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_PREFERS_DEFAULT_GPU_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_prefers_default_gpu (self, g_value_get_boolean (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_APP_TYPE_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_app_type (self, g_value_get_enum (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_COUNT_VISIBLE_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_count_visible (self, g_value_get_boolean (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_CURRENT_COUNT_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_current_count (self, g_value_get_int64 (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_MATCH_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_match (self, g_value_get_object (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 21 "../src/Backend/App.vala"
		case SLINGSHOT_BACKEND_APP_TARGET_PROPERTY:
#line 21 "../src/Backend/App.vala"
		slingshot_backend_app_set_target (self, g_value_get_object (value));
#line 21 "../src/Backend/App.vala"
		break;
#line 2090 "App.c"
		default:
#line 21 "../src/Backend/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Backend/App.vala"
		break;
#line 2096 "App.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

