/* BaseAction.c generated by valac 0.56.18, the Vala compiler
 * generated from BaseAction.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017 elementary LLC.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include "slingshot.h"
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SYNAPSE_BASE_ACTION_0_PROPERTY,
	SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY,
	SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY,
	SYNAPSE_BASE_ACTION_NUM_PROPERTIES
};
static GParamSpec* synapse_base_action_properties[SYNAPSE_BASE_ACTION_NUM_PROPERTIES];

struct _SynapseBaseActionPrivate {
	gint _default_relevancy;
	gboolean _notify_match;
};

static gint SynapseBaseAction_private_offset;
static gpointer synapse_base_action_parent_class = NULL;

static gboolean synapse_base_action_real_valid_for_match (SynapseBaseAction* self,
                                                   SynapseMatch* match);
static gint synapse_base_action_real_get_relevancy_for_match (SynapseBaseAction* self,
                                                       SynapseMatch* match);
static void synapse_base_action_real_do_execute (SynapseBaseAction* self,
                                          SynapseMatch* source,
                                          SynapseMatch* target);
static void synapse_base_action_real_execute_with_target (SynapseMatch* base,
                                                   SynapseMatch* source,
                                                   SynapseMatch* target);
static gboolean synapse_base_action_real_needs_target (SynapseMatch* base);
static SynapseQueryFlags synapse_base_action_real_target_flags (SynapseMatch* base);
static void synapse_base_action_finalize (GObject * obj);
static GType synapse_base_action_get_type_once (void);
static void _vala_synapse_base_action_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_synapse_base_action_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
synapse_base_action_get_instance_private (SynapseBaseAction* self)
{
	return G_STRUCT_MEMBER_P (self, SynapseBaseAction_private_offset);
}

static gboolean
synapse_base_action_real_valid_for_match (SynapseBaseAction* self,
                                          SynapseMatch* match)
{
	gboolean _tmp0_ = FALSE;
#line 27 "../src/synapse-core/Actions/BaseAction.vala"
	g_critical ("Type `%s' does not implement abstract method `synapse_base_action_valid_for_match'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 27 "../src/synapse-core/Actions/BaseAction.vala"
	return _tmp0_;
#line 94 "BaseAction.c"
}

gboolean
synapse_base_action_valid_for_match (SynapseBaseAction* self,
                                     SynapseMatch* match)
{
	SynapseBaseActionClass* _klass_;
#line 27 "../src/synapse-core/Actions/BaseAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../src/synapse-core/Actions/BaseAction.vala"
	_klass_ = SYNAPSE_BASE_ACTION_GET_CLASS (self);
#line 27 "../src/synapse-core/Actions/BaseAction.vala"
	if (_klass_->valid_for_match) {
#line 27 "../src/synapse-core/Actions/BaseAction.vala"
		return _klass_->valid_for_match (self, match);
#line 110 "BaseAction.c"
	}
#line 27 "../src/synapse-core/Actions/BaseAction.vala"
	return FALSE;
#line 114 "BaseAction.c"
}

static gint
synapse_base_action_real_get_relevancy_for_match (SynapseBaseAction* self,
                                                  SynapseMatch* match)
{
	gint _tmp0_;
	gint result;
#line 28 "../src/synapse-core/Actions/BaseAction.vala"
	g_return_val_if_fail (match != NULL, 0);
#line 29 "../src/synapse-core/Actions/BaseAction.vala"
	_tmp0_ = self->priv->_default_relevancy;
#line 29 "../src/synapse-core/Actions/BaseAction.vala"
	result = _tmp0_;
#line 29 "../src/synapse-core/Actions/BaseAction.vala"
	return result;
#line 131 "BaseAction.c"
}

gint
synapse_base_action_get_relevancy_for_match (SynapseBaseAction* self,
                                             SynapseMatch* match)
{
	SynapseBaseActionClass* _klass_;
#line 28 "../src/synapse-core/Actions/BaseAction.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../src/synapse-core/Actions/BaseAction.vala"
	_klass_ = SYNAPSE_BASE_ACTION_GET_CLASS (self);
#line 28 "../src/synapse-core/Actions/BaseAction.vala"
	if (_klass_->get_relevancy_for_match) {
#line 28 "../src/synapse-core/Actions/BaseAction.vala"
		return _klass_->get_relevancy_for_match (self, match);
#line 147 "BaseAction.c"
	}
#line 28 "../src/synapse-core/Actions/BaseAction.vala"
	return -1;
#line 151 "BaseAction.c"
}

static void
synapse_base_action_real_do_execute (SynapseBaseAction* self,
                                     SynapseMatch* source,
                                     SynapseMatch* target)
{
#line 32 "../src/synapse-core/Actions/BaseAction.vala"
	g_critical ("Type `%s' does not implement abstract method `synapse_base_action_do_execute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 32 "../src/synapse-core/Actions/BaseAction.vala"
	return;
#line 163 "BaseAction.c"
}

void
synapse_base_action_do_execute (SynapseBaseAction* self,
                                SynapseMatch* source,
                                SynapseMatch* target)
{
	SynapseBaseActionClass* _klass_;
#line 32 "../src/synapse-core/Actions/BaseAction.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/synapse-core/Actions/BaseAction.vala"
	_klass_ = SYNAPSE_BASE_ACTION_GET_CLASS (self);
#line 32 "../src/synapse-core/Actions/BaseAction.vala"
	if (_klass_->do_execute) {
#line 32 "../src/synapse-core/Actions/BaseAction.vala"
		_klass_->do_execute (self, source, target);
#line 180 "BaseAction.c"
	}
}

static void
synapse_base_action_real_execute_with_target (SynapseMatch* base,
                                              SynapseMatch* source,
                                              SynapseMatch* target)
{
	SynapseBaseAction * self;
	gboolean _tmp0_;
#line 33 "../src/synapse-core/Actions/BaseAction.vala"
	self = (SynapseBaseAction*) base;
#line 34 "../src/synapse-core/Actions/BaseAction.vala"
	synapse_base_action_do_execute (self, source, target);
#line 35 "../src/synapse-core/Actions/BaseAction.vala"
	_tmp0_ = self->priv->_notify_match;
#line 35 "../src/synapse-core/Actions/BaseAction.vala"
	if (_tmp0_) {
#line 35 "../src/synapse-core/Actions/BaseAction.vala"
		g_signal_emit_by_name (source, "executed");
#line 201 "BaseAction.c"
	}
}

static gboolean
synapse_base_action_real_needs_target (SynapseMatch* base)
{
	SynapseBaseAction * self;
	gboolean result;
#line 38 "../src/synapse-core/Actions/BaseAction.vala"
	self = (SynapseBaseAction*) base;
#line 39 "../src/synapse-core/Actions/BaseAction.vala"
	result = FALSE;
#line 39 "../src/synapse-core/Actions/BaseAction.vala"
	return result;
#line 216 "BaseAction.c"
}

static SynapseQueryFlags
synapse_base_action_real_target_flags (SynapseMatch* base)
{
	SynapseBaseAction * self;
	SynapseQueryFlags result;
#line 42 "../src/synapse-core/Actions/BaseAction.vala"
	self = (SynapseBaseAction*) base;
#line 43 "../src/synapse-core/Actions/BaseAction.vala"
	result = SYNAPSE_QUERY_FLAGS_ALL;
#line 43 "../src/synapse-core/Actions/BaseAction.vala"
	return result;
#line 230 "BaseAction.c"
}

SynapseBaseAction*
synapse_base_action_construct (GType object_type)
{
	SynapseBaseAction * self = NULL;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	self = (SynapseBaseAction*) synapse_match_construct (object_type);
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	return self;
#line 241 "BaseAction.c"
}

gint
synapse_base_action_get_default_relevancy (SynapseBaseAction* self)
{
	gint result;
#line 24 "../src/synapse-core/Actions/BaseAction.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../src/synapse-core/Actions/BaseAction.vala"
	result = self->priv->_default_relevancy;
#line 24 "../src/synapse-core/Actions/BaseAction.vala"
	return result;
#line 254 "BaseAction.c"
}

void
synapse_base_action_set_default_relevancy (SynapseBaseAction* self,
                                           gint value)
{
	gint old_value;
#line 24 "../src/synapse-core/Actions/BaseAction.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/synapse-core/Actions/BaseAction.vala"
	old_value = synapse_base_action_get_default_relevancy (self);
#line 24 "../src/synapse-core/Actions/BaseAction.vala"
	if (old_value != value) {
#line 24 "../src/synapse-core/Actions/BaseAction.vala"
		self->priv->_default_relevancy = value;
#line 24 "../src/synapse-core/Actions/BaseAction.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_base_action_properties[SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY]);
#line 272 "BaseAction.c"
	}
}

gboolean
synapse_base_action_get_notify_match (SynapseBaseAction* self)
{
	gboolean result;
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
	result = self->priv->_notify_match;
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
	return result;
#line 286 "BaseAction.c"
}

void
synapse_base_action_set_notify_match (SynapseBaseAction* self,
                                      gboolean value)
{
	gboolean old_value;
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
	old_value = synapse_base_action_get_notify_match (self);
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
	if (old_value != value) {
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
		self->priv->_notify_match = value;
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_base_action_properties[SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY]);
#line 304 "BaseAction.c"
	}
}

static void
synapse_base_action_class_init (SynapseBaseActionClass * klass,
                                gpointer klass_data)
{
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	synapse_base_action_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	g_type_class_adjust_private_offset (klass, &SynapseBaseAction_private_offset);
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	((SynapseBaseActionClass *) klass)->valid_for_match = (gboolean (*) (SynapseBaseAction*, SynapseMatch*)) synapse_base_action_real_valid_for_match;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	((SynapseBaseActionClass *) klass)->get_relevancy_for_match = (gint (*) (SynapseBaseAction*, SynapseMatch*)) synapse_base_action_real_get_relevancy_for_match;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	((SynapseBaseActionClass *) klass)->do_execute = (void (*) (SynapseBaseAction*, SynapseMatch*, SynapseMatch*)) synapse_base_action_real_do_execute;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	((SynapseMatchClass *) klass)->execute_with_target = (void (*) (SynapseMatch*, SynapseMatch*, SynapseMatch*)) synapse_base_action_real_execute_with_target;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	((SynapseMatchClass *) klass)->needs_target = (gboolean (*) (SynapseMatch*)) synapse_base_action_real_needs_target;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	((SynapseMatchClass *) klass)->target_flags = (SynapseQueryFlags (*) (SynapseMatch*)) synapse_base_action_real_target_flags;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_synapse_base_action_get_property;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_synapse_base_action_set_property;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	G_OBJECT_CLASS (klass)->finalize = synapse_base_action_finalize;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY, synapse_base_action_properties[SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY] = g_param_spec_int ("default-relevancy", "default-relevancy", "default-relevancy", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY, synapse_base_action_properties[SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY] = g_param_spec_boolean ("notify-match", "notify-match", "notify-match", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 338 "BaseAction.c"
}

static void
synapse_base_action_instance_init (SynapseBaseAction * self,
                                   gpointer klass)
{
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	self->priv = synapse_base_action_get_instance_private (self);
#line 25 "../src/synapse-core/Actions/BaseAction.vala"
	self->priv->_notify_match = TRUE;
#line 349 "BaseAction.c"
}

static void
synapse_base_action_finalize (GObject * obj)
{
	SynapseBaseAction * self;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_BASE_ACTION, SynapseBaseAction);
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	G_OBJECT_CLASS (synapse_base_action_parent_class)->finalize (obj);
#line 360 "BaseAction.c"
}

static GType
synapse_base_action_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseBaseActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_base_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseBaseAction), 0, (GInstanceInitFunc) synapse_base_action_instance_init, NULL };
	GType synapse_base_action_type_id;
	synapse_base_action_type_id = g_type_register_static (SYNAPSE_TYPE_MATCH, "SynapseBaseAction", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SynapseBaseAction_private_offset = g_type_add_instance_private (synapse_base_action_type_id, sizeof (SynapseBaseActionPrivate));
	return synapse_base_action_type_id;
}

GType
synapse_base_action_get_type (void)
{
	static volatile gsize synapse_base_action_type_id__once = 0;
	if (g_once_init_enter (&synapse_base_action_type_id__once)) {
		GType synapse_base_action_type_id;
		synapse_base_action_type_id = synapse_base_action_get_type_once ();
		g_once_init_leave (&synapse_base_action_type_id__once, synapse_base_action_type_id);
	}
	return synapse_base_action_type_id__once;
}

static void
_vala_synapse_base_action_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SynapseBaseAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_BASE_ACTION, SynapseBaseAction);
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	switch (property_id) {
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		case SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY:
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		g_value_set_int (value, synapse_base_action_get_default_relevancy (self));
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		break;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		case SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY:
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		g_value_set_boolean (value, synapse_base_action_get_notify_match (self));
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		break;
#line 407 "BaseAction.c"
		default:
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		break;
#line 413 "BaseAction.c"
	}
}

static void
_vala_synapse_base_action_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SynapseBaseAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_BASE_ACTION, SynapseBaseAction);
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
	switch (property_id) {
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		case SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY:
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		synapse_base_action_set_default_relevancy (self, g_value_get_int (value));
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		break;
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		case SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY:
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		synapse_base_action_set_notify_match (self, g_value_get_boolean (value));
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		break;
#line 439 "BaseAction.c"
		default:
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/synapse-core/Actions/BaseAction.vala"
		break;
#line 445 "BaseAction.c"
	}
}

